<?php
/**
* @author   Vasatko
* @version  1.4
* @remarks  Copyright (C) 2011 Vasatko
* @remarks  Licensed under GNU/GPLv3, see http://www.gnu.org/licenses/gpl-3.0.html
* @see      http://vasatko.net/joomla/mapycz
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.plugin.plugin');

/** Plugin MapyCZ */
class  plgContentMapyCZ extends JPlugin {
	
	protected $map = array(
			"id"=>"",
			"name"=>"",
			"zoom"=>"4",
			"layer"=>"base",
			"width"=>"600",
			"height"=>"400",
			"longitude"=>"50.617498662097006",
			"latitude"=>"16.888087732218196",
			"markShow"=>"0",
			"markLongitude"=>"",
			"markLatitude"=>"",
			"markTitle"=>"",
			"markText"=>"",
			"language"=>"cs_CZ",
		);
	
	public function onContentPrepare($context, &$row, &$params, $page = 0){
		
		// set JavaScript form api4.mapy.cz
		$document = JFactory::getDocument();
		$head = $document->getHeadData();
		if(isset($head["scripts"]["http://api.mapy.cz/loader.js"]) && is_array($head["scripts"]["http://api.mapy.cz/loader.js"])){
			//echo "mapycz api loaded";
		}else{
			$document->addStyleDeclaration("#mapycz td, #mapycz tr {border:0px !important;}");
			$document->addScript("http://api.mapy.cz/loader.js");
			$document->addScript(JURI::root( true )."/components/com_mapycz/js/com-mapycz.js?v=1.4");
			$document->addScriptDeclaration("Loader.load();");	
			
			$style = 'img {'
			. 'max-width: none;'
			. 'min-width: none;'
			. '}'; 
			$document->addStyleDeclaration($style);
			
		}
	
		// replace from {mapycz id=...} to map with id
		$regex = '/{mapycz\sid=([^}]*)}/i';
        @preg_match_all($regex,$row->text,$matches);
		if(@count($matches[0])>0) {
			foreach($matches[0] as $i => $repl) {
				$from=array('{','}','mapycz'); $to=array('','','');								
				$row->text = str_replace($repl,$this->_getMap(trim($matches[1][$i])),$row->text);						
			}								
		}	
		unset($matches);
		
		// replace from {mapycz-link map-id=... marker-id=...} to link on map marker
		$regex = '/{mapycz-link\smap-id=([0-9]*)\smarker-id=([0-9]*)}/i';
        @preg_match_all($regex,$row->text,$matches);
		if(@count($matches[0])>0) {
			foreach($matches[0] as $i => $repl) {
				$mapId=$matches[1][$i];
				$markerId=$matches[2][$i];
				$linkStart=$matches[0][$i];
				$linkEnd="{/mapycz-link}";
				$linkText=substr($row->text,(strpos($row->text,$linkStart)+strlen($linkStart)),strlen($row->text));
				$linkText=substr($linkText,0,(strpos($linkText,$linkEnd)));
				/*echo "map=".$mapId." mark=".$markerId."<br/>";
				echo "link-start=".$linkStart."<br/>";
				echo "link-text=".$linkText."<br/>";
				echo "link-end=".$linkEnd."<br/>";
				echo "<hr/><hr/>";*/
				$row->text = str_replace($linkStart.$linkText.$linkEnd,$this->_getLink($mapId,$markerId,$linkText),$row->text);						
			}								
		}
	
		// replace from {mapycz-link map-id=... marker-id=... zoom=... layer=...} to link on map marker
		$regex = '/{mapycz-link\smap-id=([0-9]*)\smarker-id=([0-9]*)\szoom=([0-9]*)\slayer=([^}]*)}/i';
        @preg_match_all($regex,$row->text,$matches);
		if(@count($matches[0])>0) {
			foreach($matches[0] as $i => $repl) {
				$mapId=$matches[1][$i];
				$markerId=$matches[2][$i];
				$mapZoom=$matches[3][$i];
				$mapLayer=$matches[4][$i];
				$linkStart=$matches[0][$i];
				$linkEnd="{/mapycz-link}";
				$linkText=substr($row->text,(strpos($row->text,$linkStart)+strlen($linkStart)),strlen($row->text));
				$linkText=substr($linkText,0,(strpos($linkText,$linkEnd)));
				/*echo "map=".$mapId." mark=".$markerId." zoom=".$mapZoom." layer=".$mapLayer."<br/>";
				echo "link-start=".$linkStart."<br/>";
				echo "link-text=".$linkText."<br/>";
				echo "link-end=".$linkEnd."<br/>";
				echo "<hr/><hr/>";		*/						
				$row->text = str_replace($linkStart.$linkText.$linkEnd,$this->_getLink($mapId,$markerId,$linkText,$mapZoom,$mapLayer),$row->text);						
			}								
		}
		
		// replace from {mapycz-link map-id=... marker-id=... zoom=...} to link on map marker
		$regex = '/{mapycz-link\smap-id=([0-9]*)\smarker-id=([0-9]*)\szoom=([^}]*)}/i';
        @preg_match_all($regex,$row->text,$matches);
		if(@count($matches[0])>0) {
			foreach($matches[0] as $i => $repl) {
				$mapId=$matches[1][$i];
				$markerId=$matches[2][$i];
				$mapZoom=$matches[3][$i];
				$mapLayer=null;
				$linkStart=$matches[0][$i];
				$linkEnd="{/mapycz-link}";
				$linkText=substr($row->text,(strpos($row->text,$linkStart)+strlen($linkStart)),strlen($row->text));
				$linkText=substr($linkText,0,(strpos($linkText,$linkEnd)));
				/*echo "map=".$mapId." mark=".$markerId." zoom=".$mapZoom." layer=".$mapLayer."<br/>";
				echo "link-start=".$linkStart."<br/>";
				echo "link-text=".$linkText."<br/>";
				echo "link-end=".$linkEnd."<br/>";
				echo "<hr/><hr/>";*/								
				$row->text = str_replace($linkStart.$linkText.$linkEnd,$this->_getLink($mapId,$markerId,$linkText,$mapZoom,$mapLayer),$row->text);						
			}								
		}
	
		// replace from {mapycz-link map-id=... marker-id=... layer=...} to link on map marker
		$regex = '/{mapycz-link\smap-id=([0-9]*)\smarker-id=([0-9]*)\slayer=([^}]*)}/i';
        @preg_match_all($regex,$row->text,$matches);
		if(@count($matches[0])>0) {
			foreach($matches[0] as $i => $repl) {
				$mapId=$matches[1][$i];
				$markerId=$matches[2][$i];
				$mapZoom=null;
				$mapLayer=$matches[3][$i];
				$linkStart=$matches[0][$i];
				$linkEnd="{/mapycz-link}";
				$linkText=substr($row->text,(strpos($row->text,$linkStart)+strlen($linkStart)),strlen($row->text));
				$linkText=substr($linkText,0,(strpos($linkText,$linkEnd)));
				/*echo "map=".$mapId." mark=".$markerId." zoom=".$mapZoom." layer=".$mapLayer."<br/>";
				echo "link-start=".$linkStart."<br/>";
				echo "link-text=".$linkText."<br/>";
				echo "link-end=".$linkEnd."<br/>";
				echo "<hr/><hr/>";*/								
				$row->text = str_replace($linkStart.$linkText.$linkEnd,$this->_getLink($mapId,$markerId,$linkText,$mapZoom,$mapLayer),$row->text);						
			}								
		}
			
	}
	
	function _getLink($mapId, $markerId, $text, $zoom=null, $layer=null) {
		
		$cnt = '';
		$cnt .= '<a href="javascript:return false" onclick="mapycz_marker_activate('.$mapId.','.$markerId.','.(($zoom==null)?'null':$zoom).',\''.(($layer==null)?'null':$layer).'\');return false;">'.$text.'</a>';
		
		return $cnt;
		
		
	}
	
	function _getMap($id) {
		
		try{
		
			// load db
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
		
			// set query for select all data about selected map
			$query->select('*');
			$query->from('#__mapycz');
			$query->where('id = '.$db->quote($id));
		
			// set query and create query
			$db->setQuery($query);		
			$this->map = array_merge($this->map,$db->loadAssoc());
			
			//echo nl2br(str_replace('#__','jos_',$query));
		
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
				
		// javascript		
		$cnt = "
			
			jQuery(document).ready(function($) {
			
			if(!mapycz_map_controls || mapycz_map_controls.length<0)
				var mapycz_map_controls = new Array();
			
			mapycz_map_controls[".$id."] = 0;
			
			// vytvoreni pozic
			var coords = SMap.Coords.fromWGS84('".$this->map['latitude']."','".$this->map['longitude']."');
	
			// vytvoreni mapy
			mapycz_map[".$id."] = new SMap(JAK.gel('mapycz-".$id."-in'), coords, ".$this->map['zoom'].");
		
			// fix pro nulove rozmery mapy uvnitr boxu na mapu
			/*box = mapycz_map[".$id."].getContainer();
			inbox = $(box).children();
			inbox.each(function(i){
				if(i==0)
					$(this).css('width','".$this->map['width']."px');
					$(this).css('height','".$this->map['height']."px');
			});*/
		
			// nastaveni vrstvy
			var layer = '".$this->map['layer']."';
			if(layer=='turist')
				mapycz_layer[SMap.DEF_TURIST]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_TURIST).enable();
			else
				mapycz_layer[SMap.DEF_TURIST]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_TURIST);
			if(layer=='ophto')
				mapycz_layer[SMap.DEF_OPHOTO]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO).enable();
			else
				mapycz_layer[SMap.DEF_OPHOTO]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO);
			if(layer=='ophto0203')
				mapycz_layer[SMap.DEF_OPHOTO0203]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO0203).enable();
			else
				mapycz_layer[SMap.DEF_OPHOTO0203]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO0203);
			if(layer=='ophto0406')
				mapycz_layer[SMap.DEF_OPHOTO0406]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO0406).enable();
			else
				mapycz_layer[SMap.DEF_OPHOTO0406]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_OPHOTO0406);
			if(layer=='historic')
				mapycz_layer[SMap.DEF_HISTORIC]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_HISTORIC).enable();
			else
				mapycz_layer[SMap.DEF_HISTORIC]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_HISTORIC);
			if(layer=='base' || layer=='')
				mapycz_layer[SMap.DEF_BASE]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_BASE).enable();
			else
				mapycz_layer[SMap.DEF_BASE]=mapycz_map[".$id."].addDefaultLayer(SMap.DEF_BASE);
				
			
			// pridani vrstvy pro znacku
			var layMarker = new SMap.Layer.Marker();
			mapycz_map[".$id."].addLayer(layMarker);
			layMarker.enable();
			
			// vycentrovani na znacku, pri otevreni vizitky
			mapycz_map[".$id."].getSignals().addListener(window, 'card-open', function(e) {
				mapycz_map[".$id."].redraw();
				var card = e.target;
				var coords = card.getAnchor();
				mapycz_map[".$id."].setCenter(coords, true);
			});
			
			// presmerovani po kliku na znacku, pokud ma nastaven link
			mapycz_map[".$id."].getSignals().addListener(window, 'marker-click', function(e) {
				mapycz_map[".$id."].redraw();
				var marker = e.target;
				var markerId = marker.getId().replace('mapycz_marker','');
				if(marker_links[markerId] && marker_links[markerId]!='undefined')
					window.location.href = marker_links[markerId];
			});
			
		";
		
		// if show controls
		if($this->map['controls']!=0){
			$cnt.="
				// prepinac vrstev
				var layerSwitch = new SMap.Control.Layer();
				layerSwitch.addDefaultLayer(SMap.DEF_BASE);
				layerSwitch.addDefaultLayer(SMap.DEF_TURIST);
				layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO);
				layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO0203);
				layerSwitch.addDefaultLayer(SMap.DEF_OPHOTO0406);
				layerSwitch.addDefaultLayer(SMap.DEF_HISTORIC);

				// nastaveni ovladacich prvku
				jQuery('#mapycz-".$id."-in').click(function(){
					if(mapycz_map_controls[".$id."]==0){
						mapycz_map[".$id."].addControl(layerSwitch,{left:'8px', top:'8px'});
						mapycz_map[".$id."].addDefaultControls();
					}
					mapycz_map_controls[".$id."] = 1;
					
				});";
		}
		
		// load markers
		try{
		
			// load db
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
		
			// set query for select all data about selected map
			$query->select('*');
			$query->from('#__mapycz_marks');
			$query->where('mapId = '.$db->quote($id));
		
			// set query and create query
			$db->setQuery($query);		
			$markers = $db->loadObjectList();
			
			//echo nl2br(str_replace('#__','jos_',$query));
		
		}catch (Exception $e){
			echo $e->getMessage();exit;
			$this->setError($e->getMessage());
			return false;
		}
		
		$cnt .= "var marker_links = new Array();";
		
		foreach($markers as $i=>$marker){
			
			$options[$i] = array();
				
			if($marker->link=='' && ($marker->title!="" || $marker->text!="")){
				$cnt.="
					// pridani vizitky
					mapycz_card[".$marker->id."] = new SMap.Card();
					mapycz_options[$i] = {};";
			}
			
			if($marker->shortcut!=""){
				$cnt.="
					// prida text do znacky
					mapycz_markerBox[$i] = JAK.mel('div');
					mapycz_markerImg[$i] = JAK.mel('img', {src:'".JURI::root( true )."/administrator/components/com_mapycz/assets/images/marker-".$marker->color.".png'});
					mapycz_markerBox[$i].appendChild(mapycz_markerImg[$i]);
					mapycz_markerTxt[$i] = JAK.mel('div', {}, {position:'absolute', left:'0px', top:'3px', textAlign:'center', width:'22px', color:'white', fontWeight:'bold', fontSize:'11px'});
					mapycz_markerTxt[$i].innerHTML = '".$marker->shortcut."';
					mapycz_markerBox[$i].appendChild(mapycz_markerTxt[$i]);
				";
				$options[$i]['url']='mapycz_markerBox['.$i.']';
			}else{
				$cnt.="
					// prida text do znacky
					mapycz_markerBox[$i] = JAK.mel('div');
					mapycz_markerImg[$i] = JAK.mel('img', {src:'".JURI::root( true )."/administrator/components/com_mapycz/assets/images/marker-".$marker->color.".png'});
					mapycz_markerBox[$i].appendChild(mapycz_markerImg[$i]);
				";
				$options[$i]['url']='mapycz_markerBox['.$i.']';
			}
			
			if($marker->link!=""){
				$cnt.="
					// pridani linku ke znacce \n
					marker_links[".$marker->id."] = '".$marker->link."'; \n
					mapycz_markerImg[$i].style.cursor = 'pointer'; \n
				";
				if($marker->shortcut!=""){
				$cnt.="
					mapycz_markerTxt[$i].style.cursor = 'pointer'; \n";
				}
			}
			
			if($marker->link=='' && $marker->title!=""){
				$cnt.="
					// pridani nadpisu do vizitky
					mapycz_card[".$marker->id."].getHeader().innerHTML = '<strong>".$marker->title."</strong>';";
					$options[$i]['title']="'".$marker->title."'";
			}
		
			if($marker->link=='' && $marker->text!=""){
				$cnt.="
					// pridani nadpisu do vizitky
					mapycz_card[".$marker->id."].getBody().innerHTML = '".nl2br(addslashes(str_replace(chr(10),"",$marker->text)))."';";
			}
			
			$cnt.="mapycz_options[$i]={";
			foreach($options[$i] as $ii=>$option){
				$cnt.=$ii.":".$option.",";
			}
			$cnt.="};";
			
			$cnt.="
				// pridani znacky
				mapycz_markerCoordsX[".$marker->id."] = '".$marker->latitude."';
				mapycz_markerCoordsY[".$marker->id."] = '".$marker->longitude."';
				mapycz_markerCoords[$i] = SMap.Coords.fromWGS84('".$marker->latitude."','".$marker->longitude."');
				mapycz_marker[".$marker->id."] = new SMap.Marker(mapycz_markerCoords[$i], 'mapycz_marker".$marker->id."', mapycz_options[$i]);\n"; 
				if($marker->link=="" && ($marker->title!="" || $marker->text!="")){
					$cnt.="mapycz_marker[".$marker->id."].decorate(SMap.Marker.Feature.Card, mapycz_card[".$marker->id."]);\n";
				}
				$cnt.="layMarker.addMarker(mapycz_marker[".$marker->id."]);\n";
		}
		
		$cnt.="});";
		
		//echo nl2br(htmlentities($cnt));exit;
		return '<div id="mapycz-'.$id.'"><div id="mapycz-'.$id.'-in" class="mapycz-in" style="height:'.$this->map['height'].'px; width:'.$this->map['width'].'px;"></div></div><script type="text/javascript">'.$cnt.'</script>';
	}
}
